Subject: Announcing quota for linux
From: mvw <[email-masked]>
Date: Sat, 3 Jul 93 00:10:52 GMT
Newsgroups: comp.os.linux.announce

Hi,

Ok it has taken some time but it is finaly there, a BETA implementation
of quota for the LINUX operating system. I must say that this is beta
code. So don't blame me if you have problems with it and make sure you
have a good backup of your stuff. It seems to work ok but you never know.

These new package is based on the stuff that Edvard Tuinder made for the
0.95 LINUX kernel and some more recent things he made. I rewrote the whole
kernel stuff and changed the interface to be just like the one 386BSD has.
I also ported most of the quota programs from BSD to LINUX. I only need
the source of rquotad if that is freely available. If you have it please
mail it. The quota-header file is simular to the one used in BSD systems.
The quota struct on user-level is exactly the same as used on BSD systems
so that should make it easy to port more programs that use quota stuff.

Please note that the complete quota stuff is integrated into the 
VFS-layer of LINUX. This should make it possible to use on the most
filesystems as we are having now. I only tried it on ext2fs and extfs.
But it should be possible to use it on MS-DOS filesystems. :-
I only have some little problems with files with a lot of NULL's
these are much smaller on disk then there inode-size say they are.
Because I need to know how much must be allocated before doing a lolevel
write. This is why I use the inode-size of a file maybe this can be changed
in the future.

The utils included in the package are mostly ported commands from BSD
sources with some modifications by me because of little differences
between BSD and LINUX. The only thing we had to make completly new was
the quotacheck program. Because the BSD quota stuff is only usable for
ufs-filesystems we had to write that one from scratch. This one is a
user-level one that doesn't use raw-device info but readdir to walk
trough the filesystem-tree. It seem to be quite fast even on IDE-disks.

Ok now something for the library makers. I need a new errornumber in
the errno.h file and the sys_err list. Could the EDQUOT erronumber
please be added. For now I use EROFS but I like to change to a normal
EDQUOT in the next release.

The package contains :
	- kernel diffs for 0.99pl10 source tree (without alpha diffs)
	  (Please read the file README.FIRST on how to install !)
	- documents on most programs.
	- quotaon/quotaoff program (ported from BSD)
	- edquota program (ported from BSD)
	- repquota program (ported from BSD)
	- quota program (ported from BSD)
	- quotacheck program (new one)
	- some diffs for strace2 to trace calls to quotactl.

I probably forgot something but if you want more info read the files
README.FIRST and doc/implementation.notes.

Authors of this quota implementation :

Marco van Wieringen <[email-masked]> | <[email-masked]>
Edvard Tuinder  <[email-masked]> | [email-masked]>

For direct reaction please send mail the next couple of weeks 
to <[email-masked]>.

And more important where to find it :

sunsite.unc.edu:/pub/Linux/Incoming/quota1-0.tgz

(should be moved somewhere else, could I please get a directory in the
 BETA dir over there :-)

--
Send submissions for comp.os.linux.announce to: [email-masked]